diff --git a/services/java/com/android/server/AquiferService.java b/services/java/com/android/server/AquiferService.java
new file mode 100644
index 0000000..0c515cd
--- /dev/null
+++ b/services/java/com/android/server/AquiferService.java
@@ -0,0 +1,1979 @@
+package com.android.server;
+
+import android.app.ActivityManager;
+import android.app.ActivityManager.RunningAppProcessInfo;
+import android.app.ActivityManager.RunningServiceInfo;
+import android.content.pm.PackageManager;
+import android.content.pm.PackageInfo;
+import android.content.pm.ActivityInfo;
+import android.content.pm.ServiceInfo;
+import android.content.ComponentName;
+import android.content.Context;
+import android.content.Intent;
+import android.os.Handler;
+import android.os.IAquiferService;
+import android.os.Looper;
+import android.os.Message;
+import android.os.Process;
+import android.util.Log;
+import java.util.HashMap;
+import java.util.Map;
+import java.util.ArrayList;
+import android.os.Binder;
+import android.os.ServiceManager;
+import java.util.Collection;
+import java.util.Iterator;
+import java.util.ListIterator;
+import android.util.SparseArray;
+//Aquifer API
+import android.os.ComponentScreen;
+import android.os.Enforcement;
+import android.os.Filter;
+import android.os.Policy;
+import android.os.AquiferList;
+import android.os.Participant;
+import java.io.EOFException;
+import java.io.File;
+import java.io.FileInputStream;
+import java.io.FileOutputStream;
+import java.io.ObjectInputStream;
+import java.io.ObjectOutputStream;
+import java.io.ByteArrayOutputStream;
+import java.io.ObjectInputStream;
+import java.io.ByteArrayInputStream;
+//SECURITY 
+import java.io.IOException;
+import java.math.BigInteger;
+import java.nio.charset.Charset;
+import java.security.KeyPair;
+import java.security.KeyPairGenerator;
+import java.security.KeyStore;
+import java.security.MessageDigest;
+import java.security.PrivateKey;
+import java.security.PublicKey;
+import java.security.SecureRandom;
+import java.security.Signature;
+import java.lang.StackTraceElement;
+import java.lang.Thread;
+import android.app.Activity;
+import java.util.Random;
+public class AquiferService extends IAquiferService.Stub 
+    {
+   	private static final String TAG = "AquiferService";
+	private Context mContext;
+	//private static final int POLICY_SIZE = 1024;
+	private static final int POLICY_SIZE = 224;
+	private static final int POLICY_VALID = 2;
+	private static final int POLICY_INVALID = 3;
+	private static final HashMap<String, WLabel> WorkflowMap = new HashMap<String, WLabel>();  	
+	private static final HashMap<String, String> WorkflowKey = new HashMap<String, String>();  	
+	private static final HashMap<String,HashMap<String, Policy>> file_label = new HashMap<String,HashMap<String, Policy>>();  	
+	private static HashMap<String, Integer> PackageMap = new HashMap<String, Integer>();
+	//Constructor
+	public AquiferService(Context context) 
+    	{
+		super();
+		mContext = context;
+		Log.i(TAG, "AquiferService Constructed");
+		int n=5;
+
+		//Commenting socket creation for now
+               int x=democallThread(n);
+               System.out.println("RESULT OF DEMOCALL ="+x);
+
+		//Creating the file to hold filePolicyMaps
+		File file = new File("/data/system/aquifermap");
+		try{
+			if(!file.exists()){
+		        	file.createNewFile();
+		       		System.out.print("PackageMap file /data/system/aquifermap created");
+				FileOutputStream f = new FileOutputStream(file);
+		        	ObjectOutputStream s = new ObjectOutputStream(f);
+		        	s.writeObject(PackageMap);
+		        	s.close();
+			}
+		}
+		catch(Exception e)
+		{
+			System.out.println("File Creation Error:AquiferService:"+e);
+			
+		}
+
+		
+    	}
+	public String hi(int val)
+	{
+		return "hello"+val;
+	}
+
+	private int message(final int pid, final int inode, final int mask, byte[] policy)
+    	{   	
+		//System.out.println("Enters message");
+		new Thread(new Runnable() {
+                        public void run() {
+				//System.out.println("Data from JNI:"+pid+"::"+inode+".");
+				synchronized(this)
+				{
+					//fileAccess(pid,inode);
+				}
+				//do something
+                        }
+                }).start();
+        	return 0;
+    	}
+
+	private int readFile( final int pid, int inode, int mask, final int[] policy)
+	{
+		//System.out.println("readFile called from the jni:"+policy[0]+"pid="+pid+"inode="+inode);
+		/*
+		new Thread(new Runnable() {
+                        public void run() {
+				*/
+                                synchronized(this)
+                                {
+                                        readFileInternal(pid,policy);
+                                }
+				/*
+                        }
+                }).start();
+		*/
+		return 0;
+	}
+		
+	private int[] writeFile( final int pid, int inode, int mask, final int[] policy)
+        {
+                //System.out.println("writeFile called from the jni:"+policy[0]+"pid="+pid+"inode="+inode);
+               // new Thread(new Runnable() {
+                 //       public void run() {
+                                synchronized(this)
+                                {
+                                        return writeFileInternal(pid,policy);
+                                }
+                       // }
+               // }).start();
+        }
+/**************************************************************************************************************/
+	//Specific AquiferService Management Functions
+
+	//Checks if the process is a part of this workflow
+	public boolean isThisWorkflow(String sprocessName, int spid, String rprocessName, int rpid)
+	{
+		//TODO: Validate caller here.
+		String sindex = sprocessName+":"+spid;
+		String rindex = rprocessName+":"+rpid;
+		if(sindex.equals(rindex))
+		{
+			//System.out.println("Started by self");
+			return true;
+		}
+	
+		WLabel slabel=null;
+		String skey=null;
+		if(sprocessName!=null)
+                        skey = WorkflowKey.get(sindex);
+		if(skey==null)
+		{	//System.out.println("Null key for sender "+sindex);
+			return false;
+		}
+		else
+		{
+			slabel = WorkflowMap.get(skey);
+                	if(slabel==null)
+                	{
+				//System.out.println("Null label for sender "+sindex);
+				return false;
+			}	
+		}
+
+		WLabel rlabel=null;
+		String rkey=null;
+		if(rprocessName!=null)
+                        rkey = WorkflowKey.get(rindex);
+		if(rkey==null)
+		{	//System.out.println("Null key for receiver "+rindex);
+			return false;
+		}
+		else
+		{
+			rlabel = WorkflowMap.get(rkey);
+                	if(rlabel==null)
+                	{
+				//System.out.println("Null label for receiver "+rindex);
+				return false;
+			}	
+		}
+		if(rkey.equals(skey))
+		{	
+			//System.out.println("Process "+rindex+ "created in the same workflow pointed by "+skey);
+			return true;
+		}
+		return false;
+	}
+	//Adding a component to an existing participant
+	public void addComponent( String sprocessName, int spid, String spackageName, int suid, int resultcode ,String rcomponentName) {
+		validateCaller();
+		WLabel label=null;
+                String index=sprocessName+":"+spid;
+		System.out.println("Adding component "+rcomponentName+" started by "+index);
+                String key=null;
+                if(sprocessName!=null)
+                        key = WorkflowKey.get(index);
+		if(key==null)
+		{
+			//System.out.println("AquiferService:No workflowKey for "+index+" in addComponent");
+			//Get all the fields and addParticipant(sprocessName, spid, );
+			addParticipant( sprocessName, spid, sprocessName, spid, spackageName, suid, resultcode, rcomponentName);
+			return;
+		}
+		
+		label=WorkflowMap.get(key);
+                if(label==null)
+                {
+                        //System.out.println("AquiferService:addComponent: Error!!No workflow for key:"+key);
+                                //TODO: Handle by removing the index's entry from WorkflowKey
+                }
+                else
+                {       synchronized(this)
+                 	{    
+				Iterator<Participant> iterator = label.ParticipantList.iterator();
+                        	while(iterator.hasNext())
+                       		{
+                               		Participant part = iterator.next();
+                               		int part_pid = part.getPid();
+					String part_processName = part.getProcessName();
+					String part_index=part_processName + ":" + part_pid;
+					if(part_index.equals(index))
+					{
+						part.addComponent(rcomponentName, resultcode);
+						//System.out.println("Successfully added component "+rcomponentName);
+						break;
+					}
+                       		}					
+				//Adding the component to the HistoryList
+				Iterator<Participant> iterator2 = label.HistoryList.iterator();
+                                while(iterator.hasNext())
+                                {
+                                        Participant part = iterator.next();
+                                        int part_pid = part.getPid();
+                                        String part_processName = part.getProcessName();
+                                        String part_index=part_processName + ":" + part_pid;
+                                        if(part_index.equals(index))
+                                        {
+                                                part.addComponent(rcomponentName, resultcode);
+                                                //System.out.println("Successfully added component "+rcomponentName);
+                                                break;
+                                        }
+                                }
+                        }
+		System.out.println("Printing label on adding component");
+		//label.displayLabel();
+                }
+		
+	}
+
+	
+	//Adding a participant to a workflow
+	public void addParticipant( String sprocessName, int spid, String rprocessName, int rpid, String rpackageName, int ruid, int resultcode, String rcomponentName) {
+
+		//TODO: get the componentName from the method call
+		
+		//TODO: ValidateCaller
+		//Sanity Check
+		//System.out.println("MY PID!!!!!!!!!!!!!!!!!!!!!!!!>>>>"+android.os.Process.myPid());
+		validateCaller();
+		//System.out.println("Adding participant "+rprocessName+":"+rpid+" from sender "+sprocessName+":"+spid);
+		if(rprocessName==null || rpid==0)
+		{	
+			//System.out.println("Undefined input to AquiferService:addParticipant:");
+			//System.out.println("Sender:"+sprocessName+":"+spid);
+			//System.out.println("Receiver:"+rprocessName+":"+rpid);
+			return;
+		}
+
+		WLabel label=null;
+		String index=sprocessName+":"+spid;
+		String key=null;
+		if(sprocessName!=null)
+			key = WorkflowKey.get(index);
+		ArrayList<ComponentScreen> componentList = new ArrayList<ComponentScreen>();
+		componentList.add(new ComponentScreen(rcomponentName, resultcode, System.currentTimeMillis()));
+		Participant part = new Participant(rprocessName,rpackageName,rpid, ruid,resultcode,componentList);
+		//if there is no key for the sender's index, then the receiver
+		//is being started by the launcher Thus, create a new workflow
+		//starting with the receiver.
+		if(key == null)
+		{	synchronized(this)
+			{	
+				label=createWorkflow(rprocessName, rpid);
+				if(label==null)
+					System.out.println("Workflow Creation Failure!");
+				else 
+				{	//adding the first participant to the newly created workflow
+					label.ParticipantList.add(part);
+					label.HistoryList.add(part);
+				}	
+			}
+		}
+		else // If a workflow already exists for the caller
+		{
+			//System.out.println("Adding "+rprocessName+":"+rpid+" to existing workflow of "+key);	
+			label=WorkflowMap.get(key);
+			if(label==null)
+			{	
+				System.out.println("ERROR!!No workflow for key:"+key);
+				//TODO: Handle by removing the index's entry from WorkflowKey
+			}
+			else//Everything's normal.
+			{	synchronized(this)
+				{
+					label.ParticipantList.add(part);
+                                	label.HistoryList.add(part);
+					WorkflowKey.put(rprocessName+":"+rpid,key);
+				}
+			}
+		}
+		//label.displayLabel();
+	
+		//Configsuring Internet Access Policy for the process being added to the workflow.
+		Policy effective = label.effectivePolicy();
+		//System.out.println("Checking the policy in addParticipant");
+		//System.out.println("Effective Policy, rpackagename=:"+rpackageName);
+		//effective.displayPolicy();
+
+		AquiferList ExportList=effective.getExportList();
+		if(ExportList.isEmpty())
+                {
+                        setInternet(rpid, 0);
+                        //System.out.println("Granting Internet privilege for pid "+rpid);
+		}
+   		else if(ExportList.isEMPTY())
+                {
+                        //System.out.println("Revoking Internet privilege for pid "+rpid);
+                        setInternet(rpid, 1);
+                }
+                else
+                {
+                        if(ExportList.contains(rpackageName))
+                        {       //allow
+                                setInternet(rpid, 0);
+                                //System.out.println("Granting Internet privilege for pid "+rpid);
+                        }
+                        else
+                        {       //deny
+                                //System.out.println("Revoking Internet privilege for pid "+rpid);
+                                setInternet(rpid, 1);
+                        }
+                }
+
+		//Since we added a participant, we check the RequiredList
+		requiredCheck(label, effective.getRequiredList());
+
+		//TEST: Printing all the currently running processes every time a participant is added
+		/*ActivityManager am = (ActivityManager)mContext.getSystemService(Context.ACTIVITY_SERVICE);
+		System.out.println("pid          processname");
+                for(RunningAppProcessInfo pInfo : am.getRunningAppProcesses())
+                {
+                	try{   
+				int pid=pInfo.pid;
+				String processName=pInfo.processName;	
+				System.out.println(pid+"          "+processName);
+                        }
+                        catch(Exception e)
+                        {
+				System.out.println("Exception at AquiferService:addParticipant,printing active processes:"+e);
+			}
+                }*/
+	}
+	
+	private int democallThread(final int n)
+	{
+		//System.out.println("Inside DEMOCALL THREAD");
+		 new Thread(new Runnable() {
+      			public void run() {
+				//System.out.println("DEMOCALL STARTS");
+        			int x=	democall(n);
+				//System.out.println("DEMOCALL FROM KERNEL RETURNS:"+x);	
+			}
+    		}).start();
+		return 0;
+	}
+	
+	//Creating a new workflow
+    	private WLabel createWorkflow(String processName, int pid)
+	{
+		WLabel label= new WLabel();
+		String index=processName+":"+pid;
+		System.out.println("Creating new workflow for "+index);
+		WorkflowMap.put(index, label);
+		WorkflowKey.put(index,index);
+		return label;
+	}
+	
+	//Adding a data "Owner's" policy, through one of its components.
+	public void addPolicy(Policy policy)
+	{
+		int current_pid = Binder.getCallingPid();
+		String processName = getProcessName(current_pid);
+		if(policy==null)
+			return;
+		//Displaying policy
+		//System.out.println("Policy to add:");
+		//policy.displayPolicy();
+
+		//ProcessName for the current pid does not exist!!
+		//Return immediately
+                if(processName == null || processName.equals(""))
+                {
+		//	System.out.println("Unknown Exception at AquiferService:addPolicy, processName="+processName);
+			return;
+		}
+		synchronized(this)
+		{//Getting the workflow for this component
+			WLabel label=null;
+                	String index=processName+":"+current_pid;
+			//System.out.println("Adding policy for "+index);
+        	        String key=null;
+		
+			//Getting the workflowKey
+			key = WorkflowKey.get(index);
+			if(key==null)
+			{
+				//System.out.println("Creating new workflow for "+index);
+				//TODO: Create workflow and add this process to it
+				//then get key again and continue	
+			}
+			
+			//Getting the workflow label from the key
+			label=WorkflowMap.get(key);
+                	if(label==null)
+                	{
+                		System.out.println("ERROR!!No workflow for key:"+key+" at AquiferService:addPolicy");
+                        	//TODO: Handle by removing the index's entry from WorkflowKey and returning??
+				//On the next attempt, a new workflow will be created due to the check above.
+				return;
+                	}
+
+			//getting the packagename, i.e. the owner for the calling process
+			String packageName = getPackageName(index, label.ParticipantList);
+	 		if(packageName == null)
+			{
+				System.out.println("Null packageName for "+index+" in the workflow");
+				return;
+			}
+			else
+			{	//Finally adding the policy for the calling Application
+				label.PolicyMap.put(packageName, policy);
+				//rechecking add reassigning the internet privilege throughout the workflow.
+				//System.out.println("Successfully added policy for package "+ packageName);
+				checkInternet(label);
+				//Printing the label
+				//label.displayLabel();
+			}
+		
+		}
+
+	}
+
+	//Returns the principalslist for the particular action
+	public AquiferList getPrincipalList(String sprocessName, int spid, String action)
+	{
+		 //validateCaller();
+		 synchronized(this)
+                 {//Getting the workflow for this component
+			try{
+                        	WLabel label=null;
+                	        String index=sprocessName+":"+spid;
+        	                String key=null;
+	
+                	        //Getting the workflowKey
+        	                key = WorkflowKey.get(index);
+	                        if(key==null)
+                        	{
+                	                System.out.println("No workflow for "+index+": Filtering Policy at AquiferPolicy: getPrincipalList");
+					return null;
+	                        }
+				//System.out.println("Key found: getPrincipalList");
+                	        //Getting the workflow label from the key
+        	                label=WorkflowMap.get(key);
+	                        if(label==null)
+                        	{
+                	                System.out.println("ERROR!!No workflow for key:"+key+" at AquiferService:getPrincipalList");
+        	                        return null;
+	                        }
+				//System.out.println("Label found: getPrincipalList");
+				Policy effective = label.effectivePolicy();
+				if(effective == null)		
+				{		
+					System.out.println("Null Effective Policy: getPrincipalList");
+					return null;
+				}
+				return effective.getFilter().getPrincipals(action);
+			}
+			catch(Exception e)
+			{
+				System.out.println("Exception at AquiferService:getPrincipalList:"+e);
+				return null;
+			}
+		}
+
+	}
+
+	//To manage the workflow in case an activity has been destroyed
+	public void destroyActivity( String componentName)
+	{
+		//get the pid and the processName of the activity being destroyed
+		int pid=Binder.getCallingPid();
+		String processName=getProcessName(pid);
+		
+		//Manage state for the activity
+		activityDestroyed(pid, processName, componentName);
+		/*
+		//Then kill its process; if it is not system or launcher or pid 0
+		if((pid!=0 && !processName.equals("system") && !processName.equals("com.launcher")))
+		{	
+			System.out.println("Killing process "+processName+":"+pid);
+			android.os.Process.killProcess(pid);	
+			
+		}
+		*/
+	}
+	private void activityDestroyed(int pid, String processName, String componentName)
+	{
+		try{
+			 WLabel label=null;
+                         String index=processName+":"+pid;
+                         String key=null;
+
+                         //Getting the workflowKey
+                         key = WorkflowKey.get(index);
+                         if(key==null)
+                         { 
+                          //      System.out.println("No workflow for "+index+": Filtering Policy at AquiferPolicy: activityDestroyed");
+                                return;
+                         }
+                        //System.out.println("Key found: activityDestroyed");
+                        //Getting the workflow label from the key
+                        label=WorkflowMap.get(key);
+                        if(label==null)
+                        { 
+                                System.out.println("ERROR!!No workflow for key:"+key+" at AquiferService:activityDestroyed");
+                                return;
+                        }
+			
+      			//Getting the participantlist, and this participant
+			ArrayList<Participant> ParticipantList = label.ParticipantList;
+                        if(ParticipantList == null)
+                        {
+                                 System.out.println("Error!:Null participant list at AquiferService:activityDestroyed");
+                                 return;
+                        }
+
+                        //Getting this participant from the Participants list
+                        Iterator<Participant> iterator = ParticipantList.iterator();
+			Participant part_this=null;
+                        while(iterator.hasNext())
+                        {
+                                Participant part = iterator.next();
+				String tempindex=part.getProcessName()+":"+part.getPid();
+				if(tempindex.equals(index))
+				{
+					part_this=part;
+					break;
+				}
+                        }
+			if(part_this==null)
+			{
+				System.out.println("No participant found for "+index+" at AquiferService:activityDestroyed");
+				return;
+			}
+			else
+			{	
+				//System.out.println("Participant "+index+" obtained.");
+			}
+
+			boolean policyRemove=true;
+			int resultcode = part_this.getResultCode();			
+			//If it returns a result, do not remove its policy
+			if(resultcode>=0)
+				policyRemove=false;
+
+			//If it does not return a result, but some of its application's components are still
+			//present in the workflow, do not remove its policy
+			if(policyRemove)
+			{
+				String packageName=part_this.getPackageName();
+				iterator = ParticipantList.iterator();
+				while(iterator.hasNext())
+	                        {
+        	                        Participant part = iterator.next();
+					String tempindex=part.getProcessName()+":"+part.getPid();
+                	                if(!tempindex.equals(index) && part.getPackageName().equals(packageName))
+                        	        {
+                                	       	policyRemove=false;
+                                        	break;
+                                	}	
+                        	}
+
+				//Check the HistoryList for a component with returncode=1,
+				//If there is one, then policyRemove=false
+				iterator = label.HistoryList.iterator();
+				while(iterator.hasNext())
+                                {
+                                        Participant part = iterator.next();
+                                        String tempindex=part.getProcessName()+":"+part.getPid();
+                                        if(!tempindex.equals(index) && part.getPackageName().equals(packageName))
+                                        {
+						//check for component with resultcode=1 		
+						ArrayList<ComponentScreen> componentList = part.getComponentList();
+						Iterator<ComponentScreen> compiterator = componentList.iterator();
+						while(compiterator.hasNext())
+						{
+							if(compiterator.next().getResultCode()==1)
+                                                	{	policyRemove=false;
+                                                		break;
+							}
+						}
+						break;
+                                        }
+                                }
+
+				if(policyRemove)
+				{	
+					label.PolicyMap.remove(packageName);
+				}
+			}
+
+			//remove from the Participants list
+			part_this.removeComponent(componentName);
+			if(part_this.isComponentEmpty())
+			{	
+				if((part_this.getPid()!=0 && !part_this.getProcessName().equals("system") && !part_this.getProcessName().equals("com.launcher")))
+                                {
+                                       // System.out.println("Killing process "+part_this.getProcessName()+":"+part_this.getPid());
+                                        //android.os.Process.killProcess(part_this.getPid());
+                        
+                                }
+				ParticipantList.remove(part_this);
+				//Removing from WorkflowKey
+				//TODO:Remove only if there is no other participant with the same processName:pid combination
+				WorkflowKey.remove(index);
+
+				//if this was the start of the workflow
+				//Make the next participant the start of the workflow
+				if(key.equals(index)){//And there is no other Participant with the same index
+					if(!ParticipantList.isEmpty())
+					{
+						iterator = ParticipantList.iterator();
+						Participant newHead = iterator.next();
+						String newHeadIndex = newHead.getProcessName() + ":" + newHead.getPid();					
+						WLabel wflowlabel =  WorkflowMap.remove(index);
+						WorkflowMap.put(newHeadIndex, wflowlabel);
+						synchronized(this)
+						{	
+							if(newHead.getProcessName() == null || newHead.getProcessName().equals(""))
+							{	
+								System.out.println("WTF::Participant process null:process="+newHead.getProcessName()+" pid="+newHead.getPid());
+								return;
+							}
+							while(iterator.hasNext())
+		                                	{
+                		                        	Participant part = iterator.next();
+                                		        	String tempindex=part.getProcessName()+":"+part.getPid();
+								WorkflowKey.put(tempindex, newHeadIndex);
+                                			}
+						}	
+					}
+					else
+					{
+						WorkflowMap.remove(index);
+					}
+				}
+			}
+			
+		}	
+		catch(Exception e)
+		{System.out.println("Exception at activityDestroy");}
+		//To maintain consistency in the workflow:
+		//policyRemove=true
+		//Check if the result code is >=0
+		//if it is, policyRemove = false	
+		//if policyRemove == true,
+		// check if there is even 1 participant with the same packagename and resultcode >=0
+		//if found even one, policyRemove=false
+
+		//remove the participant from the ParticipantList
+		//if policyRemove = true
+		// remove the package's policy frm the policy map
+	}
+	
+	public void destroyEntireProcess(String processName, int pid){
+	try{
+        	WLabel label=null;
+                String index=processName+":"+pid;
+              	String key=null;
+                //Getting the workflowKey
+                key = WorkflowKey.get(index);
+                if(key==null)
+                {
+                	//System.out.println("No workflow for "+index+": at destroyEntireProcess");
+                        android.os.Process.killProcess(pid);
+			return;
+                }
+                //Getting the workflow label from the key
+                label=WorkflowMap.get(key);
+                if(label==null)
+                {
+                        //System.out.println("ERROR!!No workflow for key:"+key+" at AquiferService:activityDestroyed");
+			android.os.Process.killProcess(pid);
+                        return;
+                }
+		
+	        //Getting the participantlist, and this participant
+                ArrayList<Participant> ParticipantList = label.ParticipantList;
+                if(ParticipantList == null)
+                {
+                        //System.out.println("Error!:Null participant list at AquiferService:activityDestroyed");
+			android.os.Process.killProcess(pid);
+                        return;
+                }
+                Iterator<Participant> iterator = ParticipantList.iterator();
+                Participant part_this=null;
+                while(iterator.hasNext())
+                {
+                	 Participant part = iterator.next();
+                         String tempindex=part.getProcessName()+":"+part.getPid();
+                         if(tempindex.equals(index))
+                         {
+                                part_this=part;
+                         	break;
+               	         }
+               	}
+               	if(part_this==null)
+               	{
+                        //System.out.println("No participant found for "+index+" at AquiferService:activityDestroyed");
+			android.os.Process.killProcess(pid);
+                        return;
+		}
+			
+		//Cleaning up the workflow
+		boolean policyRemove=true;
+                int resultcode = part_this.getResultCode();
+                //If it returns a result, do not remove its policy
+                if(resultcode>=0)
+                	policyRemove=false;
+                //If it does not return a result, but some of its application's components are still
+                //present in the workflow, do not remove its policy
+                if(policyRemove)
+                {
+                	String packageName=part_this.getPackageName();
+                        iterator = ParticipantList.iterator();
+                        while(iterator.hasNext())
+                        {
+                        	Participant part = iterator.next();
+                                String tempindex=part.getProcessName()+":"+part.getPid();
+                                if(!tempindex.equals(index) && part.getPackageName().equals(packageName))
+                                {
+                                        policyRemove=false;
+                                        break;
+                                }
+                        }
+                        if(policyRemove)
+                                label.PolicyMap.remove(packageName);
+                }
+		ParticipantList.remove(part_this);
+                WorkflowKey.remove(index);
+		//If the head is being killed, replace it with the next node
+		//If not possible, then remove the workflow.
+		if(key.equals(index)){
+                	if(!ParticipantList.isEmpty())
+                        {
+                        	iterator = ParticipantList.iterator();
+                                Participant newHead = iterator.next();
+                                String newHeadIndex = newHead.getProcessName() + ":" + newHead.getPid();
+                                WLabel wflowlabel =  WorkflowMap.remove(index);
+                                WorkflowMap.put(newHeadIndex, wflowlabel);
+                                synchronized(this)
+                                {
+                                	if(newHead.getProcessName() == null || newHead.getProcessName().equals(""))
+                                        {
+                                        	System.out.println("WTF::Participant process null:process="+newHead.getProcessName()+" pid="+newHead.getPid());
+						android.os.Process.killProcess(pid);
+                                                return;
+                                        }
+                                      	while(iterator.hasNext())
+                                        {
+                                        	Participant part = iterator.next();
+                                                String tempindex=part.getProcessName()+":"+part.getPid();
+                                                WorkflowKey.put(tempindex, newHeadIndex);
+                                        }
+                                }
+                        }
+                        else
+                        {
+                        	WorkflowMap.remove(index);
+                        }
+		}
+	}
+	catch(Exception e){
+		System.out.println("Exception while removing entire process:"+e);
+	}
+	android.os.Process.killProcess(pid);
+	return;
+	}
+	
+	//Serialize a AquiferList to an integer ArrayList
+	private void translateListToInt(AquiferList aquiferlist, ArrayList<Integer> finalPolicy)
+	{
+		finalPolicy.add(aquiferlist.size());
+		int size = aquiferlist.size();
+		int notNull = size;
+	
+		ArrayList<String> stringlist= aquiferlist.getList();
+		Iterator<String> iterator = stringlist.iterator();
+                while(iterator.hasNext())
+                {
+                        String packageName = iterator.next();
+                    	if(packageName.equals("EMPTY")){
+				finalPolicy.add(new Integer(-1));
+				continue;
+			}
+			Integer uid = getUid(packageName);
+			if(uid==null)
+			{
+				//TODO: What if more than one packages are not found. We will have more than 1 -2s, still the list won't have a -1 if necessary.
+				//Should we have such filtering at addPolicy itself?
+				//add dummy, so that you don't have to go back a few steps and update the size of the list.
+				if(size >1)
+                                	finalPolicy.add(-2);
+				else 
+					finalPolicy.add(-1);//if the list had 1 element, which is also not found, it is empty.
+				continue;
+			}
+			else finalPolicy.add(uid);
+                }
+	}
+	
+	//Serialize a policy to an ArrayList<Integer>
+	private void translateToInt(Policy policy, ArrayList<Integer> finalPolicy)
+	{
+		translateListToInt(policy.getExportList(), finalPolicy);
+		translateListToInt(policy.getRequiredList(), finalPolicy);
+	
+		//Propagating the Filter
+		//Putting the ascii representation of the Filter String	
+		//Adding the length of the filter, just to know when the filter ends
+		finalPolicy.add(policy.getFilter().getFilterMap().size());
+		for ( String action : policy.getFilter().getFilterMap().keySet())
+                {
+			//Add the ascii representation of the action string to the list.
+			addActionToList(action, finalPolicy);
+			//Add the list associated with the action string. 
+              		translateListToInt(policy.getFilter().getPrincipals(action), finalPolicy);
+                }
+	}
+
+	//Convert a PolicyMap to an intPolicyMap
+	private void policyMapToInt(HashMap<String, Policy> PolicyMap, ArrayList<Integer> finalPolicy)
+	{	
+		//For each package, we first add the packagename, followed by the policy
+		for ( String packageName : PolicyMap.keySet())
+		{
+			Integer uid = getUid(packageName);
+			if(uid == null)
+			{
+				//Since we don't add its policy, remove it from the count of policies too
+				//Thus, decrement the policycount at index 1 by 1
+				finalPolicy.set(1,(finalPolicy.get(1)-1)); 
+				continue;
+			}
+			//Add the uid, and then the corresponding policy
+			finalPolicy.add(uid);
+			translateToInt(PolicyMap.get(packageName), finalPolicy);
+		} 
+	}
+		
+	//Convert an arraylist  intPolicyMap back to a PolicyMap
+	private HashMap<String, Policy> policyIntToMap(ArrayList<Integer> intPolicyMap)
+	{	
+		HashMap<String, Policy> PolicyMap = new HashMap<String, Policy>();
+		
+		Iterator<Integer> iterator = intPolicyMap.iterator();
+		int totalOwners=0;
+		if(iterator.hasNext())
+			totalOwners = iterator.next();	
+		//Loop for owners; i.e. for every owners, decode
+                for(int i=0;i<totalOwners; i++)
+                {
+			//First get the packagename of the owner.
+			Integer uidOwner = iterator.next();
+			String ownerPackageName = getPackageName(uidOwner);
+			if(ownerPackageName == null)
+			{
+				//Skip the policy entirely, or stop here? I suggest stop here.
+				//Skipping the policy
+				//Get the export list size
+				int esize = iterator.next();
+				//skip the export list
+				while(esize!=0)
+				{
+					iterator.next();
+					esize--;
+				}
+
+				//Get the required list size
+                                int rsize = iterator.next();
+				//skip the required list
+                                while(rsize!=0)
+                                {
+                                        iterator.next();
+                                        rsize--;
+                                }
+				
+				//Skipping the filter is a bit tricky
+				//Getting the total filter count
+				int fsize = iterator.next();
+				
+				//For each filter to be skipped
+				for(int j=0;j<fsize; j++)
+				{
+					//Skipping the action name
+					//First get the action string length, and skip the action string
+					int acsize =  iterator.next();
+					while(acsize!=0);
+					{
+						iterator.next();
+						acsize--;
+					}
+				
+					//Getting the principal list size
+					int psize = iterator.next();
+					while(psize!=0)
+					{	
+						iterator.next();
+						psize--;
+					}	
+				}
+				
+				continue;//Move to the next policy to be decoded
+			}//Skipping Policy done
+
+			//Traversing the policy, and then adding it to the policyMap
+                        //Get the export list size
+			Policy policy = new Policy();
+        	        //First, the export list
+	        	int esize = iterator.next();
+			AquiferList exportlist = new AquiferList();
+			//Clear it, since we also include the empty tag as -1 while encoding.
+			exportlist.getList().clear();
+			while(iterator.hasNext() && esize!=0)
+	                {
+				esize--;
+                        	Integer uid = iterator.next();
+                        	if(uid== -1){
+                                	exportlist.add("EMPTY");
+                                	continue;
+                        	}
+				else if(uid == -2)//a package that was not found while storing this policy initially
+                                        continue;
+                        	String packageName = getPackageName(uid);
+                        	if(packageName == null)
+                        	        continue;
+                	        else exportlist.add(packageName);
+        	        }
+			//Add the exportlist to the policy.
+			policy.setExportList(exportlist);
+
+			//The requiredlist
+                        int rsize = iterator.next();
+			AquiferList requiredlist = new AquiferList();
+			//Clear it, since we also include the empty tag as -1 while encoding.
+			requiredlist.getList().clear();
+			while(iterator.hasNext() && rsize!=0)
+	                {
+				rsize--;
+                        	Integer uid = iterator.next();
+                        	if(uid== -1){
+                                	requiredlist.add("EMPTY");
+                                	continue;
+                        	}
+				else if(uid == -2)//a package that was not found while storing this policy initially
+					continue;
+                        	String packageName = getPackageName(uid);
+                        	if(packageName == null)
+                        	        continue;
+                	        else requiredlist.add(packageName);
+        	        }
+			//Add the requiredlist to the policy.
+			policy.setRequiredList(requiredlist);
+
+			//The Filter
+			Filter filter = new Filter();
+			int filtersize = iterator.next();
+			while(filtersize!=0)
+			{
+				String action = "";
+				int aclength = iterator.next();
+				while(aclength!=0)
+				{
+					int nextASCII=iterator.next();
+					action+=(char)(nextASCII);
+					aclength--;
+				}
+				AquiferList principalList = new AquiferList();
+				principalList.getList().clear();
+				int plength = iterator.next();
+				while(plength!=0)
+				{
+					Integer uid = iterator.next();
+					
+					if(uid== -1){
+                                        	principalList.add("EMPTY");
+                                        	continue;
+                                	}
+					else if(uid == -2)//a package that was not found while storing this policy initially
+                                        	continue;
+					String packageName = getPackageName(uid);
+                                	if(packageName == null)
+                                        	continue;
+                                	else principalList.add(packageName);
+						plength--;
+				}
+				
+				filter.setPrincipals(action, principalList);
+				filtersize--;
+			}
+			policy.setFilter(filter);
+			//Add the policy to the PolicyMap
+			PolicyMap.put(ownerPackageName, policy);
+                }
+		return PolicyMap;
+	}
+
+	
+	private int[] getIntFromPolicyMap(HashMap<String, Policy> PolicyMap)
+	{	
+		ArrayList<Integer> finalPolicy = new ArrayList<Integer>();
+
+		//Clear the Integer list, just as a precaution
+		finalPolicy.clear();
+
+		//Set the policy to valid in the Integer list
+		finalPolicy.add(POLICY_VALID);
+
+		//TODO:
+		//Keep a spot empty for the policy total length; initially enter 0
+		finalPolicy.add(0);
+
+		//Add the total number of policies in the map to the Integer list.
+		finalPolicy.add(PolicyMap.size());
+
+		//Serialize the policymap to the Integer list
+		policyMapToInt(PolicyMap, finalPolicy);
+
+		//Create an int[] and copy the Integer list into it. 
+		//We cannot directly convert the list into an array as we need an array of fixed size.
+		int finalPolicyInt[]= new int[POLICY_SIZE];
+		//System.out.println("SECURITY_LABEL SIZE = "+finalPolicy.size());
+		Iterator<Integer> iterator = finalPolicy.iterator();
+		int i=0;
+                while(iterator.hasNext())
+                {
+                        finalPolicyInt[i] = iterator.next();
+			i++;
+                }
+		
+		//TODO: Add the policy size, i, which includes the first 2 bits, to finalPolicyInt[1], i.e. the second position
+		finalPolicyInt[1]=finalPolicy.size();
+		return finalPolicyInt;
+	}
+	
+	//Get a PolicyMap from int[]
+	private HashMap<String, Policy> getPolicyMapFromInt(int[] source)
+	{
+		if(source[0]==POLICY_INVALID)
+		{
+			//In case of a write operation, this will be a case for the first write to the file
+			//System.out.println("No policymap for file in getPolicyMapFromInt");
+			return new HashMap<String, Policy>();
+		}	
+		HashMap<String, Policy> PolicyMap=new HashMap<String, Policy>(); 
+		try{
+			ArrayList<Integer> listPolicyMap = new ArrayList<Integer>();
+                	//Clear the Integer list, just as a precaution
+                	listPolicyMap.clear();
+			//TODO: Instead, get the length from the second bit of the source, i.e. source[1]
+			//int len = source.length;
+			int len = source[1];
+			
+			//Copy the int[] into the ArrayList; strip off the first integer as it is just a valid-invalid flag.
+			//strip off the total policy length too.
+                	for(int i=2;i<len;i++)
+                	{
+                        	listPolicyMap.add(source[i]);
+                        }
+                        PolicyMap =policyIntToMap(listPolicyMap);
+		}			
+                catch(Exception e)
+                {
+                        System.out.println("Exception at getPolicyMapFromInt wrapper:"+e);
+                }
+		return PolicyMap;
+	}
+
+	//Internal function for handling file read
+	private void readFileInternal(int pid, int[] policy)
+	{
+		try{
+
+                //Printing the integer file policy input
+		/*
+		System.out.println("Printing the source int array policy:");
+                String array="";
+                for(int i=0;i<policy.length; i++){
+                        array+=policy[i]+",";
+                }
+                System.out.println(array);
+		*/
+		//
+
+		HashMap<String, Policy> FilePolicyMap = getPolicyMapFromInt(policy);
+		//Printing the initially acquired FilePolicyMap
+		/*
+		System.out.println("Printing the initially converted FilePolicyMap:readFileInternal");
+                for(String packageName: FilePolicyMap.keySet())
+                        FilePolicyMap.get(packageName).displayPolicy();
+		*/
+		//end of printing the policy		
+
+		String processName="";
+		processName = getProcessName(pid);
+                if(processName.equals(""))
+                {
+               		//System.out.println("File Access by non-visual Component:"+pid);
+                        return;
+                }
+
+		String index=processName+":"+pid;
+                String key=null;
+		WLabel label=null;
+                //Getting the workflowKey
+                key = WorkflowKey.get(index);
+                if(key==null)
+                {
+                        //System.out.println("Key not found: Read access by system ui component, or by non-ui component:"+index);
+                        return;
+                }
+                //Getting the workflow label from the key
+                label=WorkflowMap.get(key);
+                if(label==null)
+                {
+                        //System.out.println("ERROR!!No workflow for key:"+key+" at AquiferService:fileAccess");
+                        return;
+                }
+		
+		HashMap<String, Policy> wFlowPolicyMap = null;
+                //getting the PolicyMap for the workflow
+                wFlowPolicyMap = label.PolicyMap;
+	
+		if(FilePolicyMap.isEmpty())
+                {
+			//System.out.println("Not Possible, if we avoid propagation when the workflow map is empty");
+                        return;
+                }
+		if(wFlowPolicyMap.isEmpty())
+		{
+			//Adwait: Temp changes
+			//label.PolicyMap.putAll(FilePolicyMap);	
+			label.PolicyMap=FilePolicyMap;	
+		}
+		else if(FilePolicyMap==wFlowPolicyMap)
+		{
+			//System.out.println("Identical Workflow and File Labels");
+			return;
+		}
+		else
+		{
+			//System.out.println("Intersecting PolicyMaps for "+index+" accessing file "+file_id);
+                	//getting the intersection
+			
+			//Adwait: Temp changes
+			/*
+                	HashMap<String,Policy> newMap = new HashMap<String,Policy>();
+                	//copying wFlowPolicyMap to newMap
+                   	for ( String packageName : wFlowPolicyMap.keySet())
+                        {
+                                newMap.put(packageName, wFlowPolicyMap.get(packageName));
+                        }
+
+                        //For common actions, take the intersection of the Principals
+                        for ( String packageName : FilePolicyMap.keySet())
+                        {
+
+                                if(newMap.containsKey(packageName))
+                                        newMap.put(packageName, Policy.policyJoin(wFlowPolicyMap.get(packageName), FilePolicyMap.get(packageName)));
+                                else
+                                        newMap.put(packageName, FilePolicyMap.get(packageName));
+                        }
+                        wFlowPolicyMap = newMap;
+			label.PolicyMap.putAll(wFlowPolicyMap);
+			*/
+			//
+			//For common owners, take the effective of the owner policies
+                        for ( String packageName : FilePolicyMap.keySet())
+                        {
+
+                                if(wFlowPolicyMap.containsKey(packageName))
+                                        wFlowPolicyMap.put(packageName, Policy.policyJoin(wFlowPolicyMap.get(packageName), FilePolicyMap.get(packageName)));
+                                else
+                                        wFlowPolicyMap.put(packageName, FilePolicyMap.get(packageName));
+                        }
+			label.PolicyMap=wFlowPolicyMap;
+			//
+		}
+                //Check the internet policy of the affected workflow
+                checkInternet(label);
+
+		//Printing Final Policy
+		/*
+		System.out.println("Printing the policyMap returned:readFileInternal");
+                for(String packageName: wFlowPolicyMap.keySet())
+                        wFlowPolicyMap.get(packageName).displayPolicy();
+		*/		
+		//
+		}
+		catch(Exception e)
+		{	
+			System.out.println("Exception at readFileInternal"+e);
+		}
+	}
+
+	private int[] writeFileInternal(int pid, int[] policy)
+	{
+		
+		//System.out.println("Inside writeFileInternal");
+		int returnPolicy[] = new int[POLICY_SIZE];
+		try{
+		HashMap<String, Policy> FilePolicyMap = getPolicyMapFromInt(policy);
+		String processName="";
+                processName = getProcessName(pid);
+		if(processName.equals(""))
+                {
+                        //System.out.println("File Access by non-visual Component:"+pid);
+                        returnPolicy[0]=POLICY_INVALID;
+                        return returnPolicy;
+                }
+
+		String index=processName+":"+pid;
+                String key=null;
+		WLabel label=null;
+                //Getting the workflowKey
+                key = WorkflowKey.get(index);
+                if(key==null)
+                {
+                        //System.out.println("Key not found: Write access by system ui component, or by non-ui component:"+index);
+                        returnPolicy[0]=POLICY_INVALID;
+                        return returnPolicy;
+                }
+                //Getting the workflow label from the key
+                label=WorkflowMap.get(key);
+                if(label==null)
+                {
+                        System.out.println("ERROR!!No workflow for key:"+key+" at AquiferService:fileAccess");
+                        returnPolicy[0]=POLICY_INVALID;
+                        return returnPolicy;
+                }
+
+                HashMap<String, Policy> wFlowPolicyMap = null;
+                //getting the PolicyMap for the workflow
+                wFlowPolicyMap = label.PolicyMap;
+		if(wFlowPolicyMap.isEmpty())
+                {	
+			//System.out.println("WorkflowMap for "+pid+" empty Inside writeFileInternal");
+			//return the policy on the file itself
+			//System.out.println("returning as it is");
+			returnPolicy[0]=POLICY_INVALID;
+                     	return returnPolicy;
+                }
+
+		if(FilePolicyMap.isEmpty())
+                {
+			//System.out.println("FilePolicy empty");	
+			//Adwait: Temp changes
+                	//FilePolicyMap.putAll(label.PolicyMap);  
+			FilePolicyMap=wFlowPolicyMap;
+                }
+		else if(FilePolicyMap==wFlowPolicyMap)
+                {
+                        System.out.println("Identical Workflow and File Labels");
+                        returnPolicy[0]=POLICY_INVALID;
+			return returnPolicy;
+                }
+		else
+		{	
+			//TODO: First check if they are equal.
+			//Joining the PolicyMaps
+			//Adwait: Temp changes
+			/*
+			HashMap<String,Policy> newMap = new HashMap<String,Policy>();
+                        //copying wFlowPolicyMap to newMap
+                        for ( String packageName : wFlowPolicyMap.keySet())
+                        {
+                               	newMap.put(packageName, wFlowPolicyMap.get(packageName));
+                       	}
+                       	//For common actions, take the intersection of the Principals
+                       	for ( String packageName : FilePolicyMap.keySet())
+                       	{	
+                               	if(newMap.containsKey(packageName))
+                                       	newMap.put(packageName, Policy.policyJoin(wFlowPolicyMap.get(packageName), FilePolicyMap.get(packageName)));
+                               	else   
+                               	        newMap.put(packageName, FilePolicyMap.get(packageName));
+                        }	
+
+			FilePolicyMap = newMap;
+			*/
+			//
+			//For common owners, take the effective policy
+			for ( String packageName : wFlowPolicyMap.keySet())
+                        {       
+                                if(FilePolicyMap.containsKey(packageName))
+                                        FilePolicyMap.put(packageName, Policy.policyJoin(wFlowPolicyMap.get(packageName), FilePolicyMap.get(packageName)));
+                                else   
+                                        FilePolicyMap.put(packageName, FilePolicyMap.get(packageName));
+                        }
+			//
+		}
+
+		returnPolicy = getIntFromPolicyMap(FilePolicyMap);
+		
+		//Printing the policymap returned
+		/*
+		System.out.println("WRITE:Printing the policyMap returned:");
+		for(String packageName: FilePolicyMap.keySet())
+			FilePolicyMap.get(packageName).displayPolicy();
+		*/
+		//
+		
+		//Printing the array Policy
+		/*
+		System.out.println("Printing the int array policy:");
+		String array="";
+		for(int i=0;i<returnPolicy.length; i++){
+			array+=returnPolicy[i]+",";
+		}
+		System.out.println(array);
+		System.out.println("WRITE PRINT END");
+		*/
+		//
+		
+		//Comparing the input with the returnpolicy. If the same, then we do not write the return policy
+		//
+		/*
+		int i2;
+		int polLen = returnPolicy[2];
+		for(i2=0;i2<polLen; i2++){
+                        if(returnPolicy[i2]!=policy[i2])
+			{
+				break;
+			}
+                }
+		//if the same
+		if(i2==polLen)
+			returnPolicy[0]=POLICY_INVALID;
+		*/
+		//
+
+		}
+		catch(Exception e)
+		{	
+			System.out.println("Exception at writeFileInternal"+e);
+		}
+		return returnPolicy;
+
+	}	
+
+	
+/*****************************************************************************************************************************/
+//Internet Access Privilege Management
+
+	private void checkInternet(WLabel label)
+	{	
+		//internet=0 is allow, i.e. by default a variable is defined
+		//Get the effective policy
+		Policy effective = label.effectivePolicy();
+		//System.out.println("Effective Policy at checkInternet()");
+		//effective.displayPolicy();
+		//Then get the RequiredList from the enforcement field of the policy
+		AquiferList RequiredList= effective.getRequiredList();
+		
+		//First check if the RequiredList is a subset of packages that are currently a part of the workflow
+		// i.e. the list of packages from the ParticipantList
+		boolean required=requiredCheck(label, RequiredList);
+		//System.out.println("The required check returns "+required);
+		if(!required)
+		{
+			//set the internet of all the processes to 0 and return
+			ArrayList<Participant> ParticipantList = label.ParticipantList;
+	                if(ParticipantList == null)
+	                {
+       		                 System.out.println("Error!:Null participant list at AquiferService:checkInternet(WLabel)");
+       		                 return;
+                	}
+			
+                	//Setting internet policy to deny, i.e. 1 for all participants
+                	Iterator<Participant> iterator = ParticipantList.iterator();
+                	while(iterator.hasNext())
+                	{
+                        	Participant part = iterator.next();
+                        	int part_pid = part.getPid();
+				//System.out.println("Revoking Internet privilege for pid "+part_pid);
+				setInternet(part_pid, 1);
+                	}
+			return;
+		}
+
+		//Now setting internet for each participant if it is in the allowedlist
+		AquiferList ExportList= effective.getExportList();
+		ArrayList<Participant> ParticipantList = label.ParticipantList;
+		if(ParticipantList == null)
+                {
+                        System.out.println("Error!:Null participant list at AquiferService:checkInternet(WLabel)");
+                	return;
+                }
+		allowedCheck(ExportList, ParticipantList);
+	}
+	
+	//Checking if the ExportList is satisfied in the current workflow
+	//and setting internet for each participant if it is in the allowedlist
+	private void allowedCheck(AquiferList ExportList, ArrayList<Participant> ParticipantList)
+	{
+		//First checking for conditions where the list is Full or Empty
+		//if list is full
+		if(ExportList.isEmpty())
+		{	
+			//System.out.println("Everybody is allowed");
+			//set internet for all participants and return
+			Iterator<Participant> iterator = ParticipantList.iterator();
+			while(iterator.hasNext())
+                	{	
+                        	Participant part = iterator.next();
+				int part_pid = part.getPid();
+				//System.out.println("Assigning Internet privilege for pid "+part_pid);
+				setInternet(part_pid, 0);
+			}
+			return;
+		}	
+		//if list is empty
+		else if(ExportList.isEMPTY())
+		{	
+			//System.out.println("Nobody is allowed!");
+			//set internet deny for all participants and return
+			Iterator<Participant> iterator = ParticipantList.iterator();
+                        while(iterator.hasNext())
+                        {
+                                Participant part = iterator.next();
+                                int part_pid = part.getPid();
+				//System.out.println("Revoking Internet privilege for pid "+part_pid);
+                                setInternet(part_pid, 1);
+                        }
+                        return;
+		}
+		else
+		{
+			Iterator<Participant> iterator = ParticipantList.iterator();
+                	while(iterator.hasNext())
+               		{
+                        	Participant part = iterator.next();
+				String packageName = part.getPackageName();
+                        	int part_pid = part.getPid();
+				if(ExportList.contains(packageName))
+				{	//allow
+                        	
+					setInternet(part_pid, 0);
+					//System.out.println("Granting Internet privilege for pid "+part_pid);
+				}
+				else	
+				{	//deny
+					//System.out.println("Revoking Internet privilege for pid "+part_pid);
+                        		setInternet(part_pid, 1);
+				}
+			}	
+                }
+	}
+	//Checking if the requiredList is satisfied in the current workflow
+	private static boolean requiredCheck(WLabel label, AquiferList RequiredList)
+	{
+		//First checking for conditions where the list is Full or Empty
+		//If the list is full
+                if(RequiredList.isEmpty())
+                {
+                        //All apps on a device required? Break and false
+			//System.out.println("All apps required in requiredCheck!");
+                        return false;
+                }
+                //If the list is empty
+                if(RequiredList.isEMPTY())
+                {
+			//System.out.println("No apps required in requiredCheck");
+                        return true;
+                }
+		
+		// Take the HistoryList in the ParticipantList
+                ArrayList<Participant> ParticipantList = label.HistoryList;
+                if(ParticipantList == null)
+                {
+                        //System.out.println("Error!:Null participant list at AquiferService:requiredCheck(WLabel)");
+                        return false;
+                }
+		
+		//Getting all the packageNames in a separate list
+                AquiferList packageList = new AquiferList();
+                Iterator<Participant> iterator = ParticipantList.iterator();
+                while(iterator.hasNext())
+                {
+                        Participant part = iterator.next();
+                        packageList.add(part.getPackageName());
+                }
+
+		//Checking if the RequiredList is a subset of the PackageList
+                ListIterator<String> li = RequiredList.getList().listIterator();
+                boolean required=true;
+                while(li.hasNext())
+                {	
+                        String packageName = li.next();
+                        if(!packageList.contains(packageName))
+                        {	//System.out.println("Required Package "+packageName+"not present in the workflow: requiredCheck(Wlabel)");
+                                required=false;
+                                break;
+                        }
+                }
+		return required;
+	}		
+
+	
+
+	//Setting the network policy in the kernel for a pid
+	private static void setInternet(int pid, int inetflag)
+        {
+		//System.out.println("Setting internet to "+inetflag+" for pid="+pid);
+                int val=addInetFlag(pid, inetflag);               
+                //System.out.println("returned value="+val);
+        }	
+	
+	//Returning a data "Owner's" policy to a component belonging to that owner.
+/**************************************************************************************************************/
+	//General use functions:
+		
+	private Integer getUid(String packageName)
+	{	
+		Integer uid = PackageMap.get(packageName);
+		try{
+		if(uid==null)
+		{
+			//Get the PackageMap from the file
+                        File file = new File("/data/system/aquifermap");
+                        FileInputStream f = new FileInputStream(file);
+                        ObjectInputStream s = new ObjectInputStream(f);
+                        PackageMap = (HashMap<String,Integer>)s.readObject();
+                        if(PackageMap==null)
+                        {
+                                System.out.println("Error Reading aquifermap for PackageMap:");
+                                return null;
+                        }
+                        f.close();
+                        s.close();
+			uid = PackageMap.get(packageName);
+			if(uid == null)
+			{
+				System.out.println("ERROR. No uid for packageName: "+packageName);
+			}
+		}
+		}
+		catch(Exception e)
+                {
+                        System.out.println("File Creation Error:AquiferService:"+e);
+
+                }
+		return uid;
+	}
+	private String getPackageName(Integer uid)
+	{	
+		String packageName=null;
+		//System.out.println("Looking for packagename for uid: "+uid);
+		try{
+		for ( HashMap.Entry<String, Integer> entry : PackageMap.entrySet())
+                {
+			//System.out.println("Inside HashMap");
+			int uidi = uid;
+                       	if(entry.getValue()==uidi){
+				//System.out.println("Got packagename for "+uid+ " from map");
+				packageName=entry.getKey();	
+				break;
+			}
+			else
+			{
+				//System.out.println("Entry.getValue failed="+entry.getValue()+" entry key ="+entry.getKey());
+			}
+                }	
+		if(packageName==null)
+		{
+			//System.out.println("Not found in Map");
+			//Get the PackageMap from the file
+                        File file = new File("/data/system/aquifermap");
+                        FileInputStream f = new FileInputStream(file);
+                        ObjectInputStream s = new ObjectInputStream(f);
+                        PackageMap = (HashMap<String,Integer>)s.readObject();
+                        if(PackageMap==null)
+                        {
+                                System.out.println("Error Reading aquifermap for PackageMap:");
+                                return null;
+                        }
+                        f.close();
+                        s.close();
+			
+			for ( HashMap.Entry<String, Integer> entry : PackageMap.entrySet())
+                	{
+                        	if(entry.getValue()==uid)
+                                	packageName=entry.getKey();
+               		}
+			if(packageName ==null)
+			{
+				//System.out.println("ERROR. No packageName for uid: "+uid);
+			}
+		}
+		}
+		catch(Exception e)
+                {
+                        System.out.println("File Creation Error:AquiferService:"+e);
+
+                }
+		return packageName;
+	}
+	public int storePackageName(String packageName, int uid)
+	{
+		//TODO: validate caller
+		try{
+			//Get the PackageMap from the file
+                        File file = new File("/data/system/aquifermap");
+                        FileInputStream f = new FileInputStream(file);
+                        ObjectInputStream s = new ObjectInputStream(f);
+                        PackageMap = (HashMap<String,Integer>)s.readObject();
+                        if(PackageMap==null)
+                        {
+                                System.out.println("Error Reading aquifermap for PackageMap:");
+                                return -1;
+                        }
+			f.close();
+			s.close();
+			
+			//Then add this to the PackageMap
+			PackageMap.put(packageName, new Integer(uid));
+			//Store it back to the file
+                        FileOutputStream fo = new FileOutputStream(file);
+                        ObjectOutputStream so = new ObjectOutputStream(fo);
+                        so.writeObject(PackageMap);
+			fo.close();
+                        so.close();
+			
+			//System.out.println("Package "+packageName+":"+uid+" successfully added.");
+			//Print the PackageMap; for DEBUG. TODO: Remove Later
+			int i=0; 
+			//System.out.println("Printing first 5 elements of PackageMap");
+			//for ( String packageName2 : PackageMap.keySet())
+                        //{
+			//	System.out.println(packageName2+":"+PackageMap.get(packageName2));
+                        //}
+                }
+                catch(Exception e)
+                {
+                        System.out.println("Exception at AquiferService:storePackageName while reading from file:"+e);
+                        return-1;
+                }
+		return 0;
+		//Store it back to the file
+	}	
+	public int removePackageName(String packageName)
+	{
+		//TODO: validate caller
+		try{
+			//Get the PackageMap from the file
+                        File file = new File("/data/system/aquifermap");
+                        FileInputStream f = new FileInputStream(file);
+                        ObjectInputStream s = new ObjectInputStream(f);
+                        PackageMap = (HashMap<String,Integer>)s.readObject();
+                        if(PackageMap==null)
+                        {
+                                System.out.println("Error Reading aquifermap for PackageMap:");
+                                return -1;
+                        }
+			f.close();
+			s.close();
+			
+			//Then add this to the PackageMap
+			PackageMap.remove(packageName);
+			//Store it back to the file
+                        FileOutputStream fo = new FileOutputStream(file);
+                        ObjectOutputStream so = new ObjectOutputStream(fo);
+                        so.writeObject(PackageMap);
+			fo.close();
+                        so.close();
+			
+			//System.out.println("Package "+packageName+"successfully removed.");
+			//Print the PackageMap; for DEBUG. TODO: Remove Later
+			int i=0; 
+			//System.out.println("Printing first 5 elements of PackageMap");
+			//for ( String packageName2 : PackageMap.keySet())
+                        //{
+			//	System.out.println(packageName2+":"+PackageMap.get(packageName2));
+                        //}
+                }
+                catch(Exception e)
+                {
+                        System.out.println("Exception at AquiferService:removePackageName while reading from file:"+e);
+                        return-1;
+                }
+		return 0;
+		//Store it back to the file
+	}
+        
+	//Getting the Participant's packageName
+	private static String getPackageName(String index, ArrayList<Participant> ParticipantList)
+	{
+		if(ParticipantList == null)
+		{
+			System.out.println("Null participant list at AquiferService:getPackageName(index, participantlist)");
+			return null;
+		}
+		Iterator<Participant> iterator = ParticipantList.iterator();
+		while(iterator.hasNext())
+		{
+			Participant part = iterator.next();
+			String tocompare=part.getProcessName()+":"+part.getPid();
+			if(tocompare.equals(index))
+				return part.getPackageName();
+		}
+		return null;
+	}
+
+	//Getting the processName given the pid
+	public String getProcessName(int pid)
+	{
+		ActivityManager am = (ActivityManager)mContext.getSystemService(Context.ACTIVITY_SERVICE);
+		try{
+			for(RunningAppProcessInfo pInfo : am.getRunningAppProcesses())
+			{
+				if(pInfo.pid == pid)
+					return pInfo.processName;
+			}
+		}
+		catch(Exception e)
+		{}
+		return "";
+	}
+
+	//Getting the processName given the pid
+	public String getComponentName(String processName)
+	{
+		ActivityManager am = (ActivityManager)mContext.getSystemService(Context.ACTIVITY_SERVICE);
+		for(RunningAppProcessInfo pInfo : am.getRunningAppProcesses())
+		{
+			try{
+				if(pInfo.processName.equals(processName))
+					return pInfo.importanceReasonComponent.getClassName();
+			}
+			catch(Exception e)
+			{}
+		}
+		return "";
+	}
+
+	private boolean isService(int pid)
+	{
+		
+		ActivityManager am = (ActivityManager)mContext.getSystemService(Context.ACTIVITY_SERVICE);
+                for(RunningServiceInfo pInfo : am.getRunningServices(100))
+                {
+                        try{   
+                                if(pInfo.pid == pid)
+                                        return true;
+                        }  
+                        catch(Exception e)
+                        {
+				System.out.println("Exception at AquiferService:isService(int pid):"+e);
+			}
+                }
+                return false;
+	}
+	//Get pid for processName
+	private int getPid(String processName)
+        {
+                ActivityManager am = (ActivityManager)mContext.getSystemService(Context.ACTIVITY_SERVICE);
+                for(RunningAppProcessInfo pInfo : am.getRunningAppProcesses())
+                {
+                        if(pInfo.processName.equals(processName))
+                                return pInfo.pid;
+                }
+                return -1;
+        }
+
+	//Get processName for Activity componentName
+	private String getProcessName2(ComponentName componentName)
+	{	
+		PackageManager pm = mContext.getPackageManager();
+                String ret=null;
+                try{
+			ActivityInfo ai;
+                        ai = pm.getActivityInfo(componentName,0);
+			ret = ai.processName;
+                }
+                catch(Exception e)
+                {       Log.w(TAG, "Component Not found:getProcessName2(Component)");                        
+                }
+                return ret;
+        }
+
+	//Get processName for service ComponentName
+	private String getProcessName3(ComponentName componentName)
+	{	
+		PackageManager pm = mContext.getPackageManager();
+                String ret=null;
+                try{
+			ServiceInfo si;
+                        si = pm.getServiceInfo(componentName,0);
+			ret = si.processName;
+                }
+                catch(Exception e)
+                {       Log.w(TAG, "Component Not found:getProcessName3(Component)");                        
+                }
+                return ret;
+        }
+	
+	//Getting the packageName given the uid
+/*        private String[] getPackageName(int uid)
+        {
+                PackageManager pm = mContext.getPackageManager();
+                String[] ret=null;
+                try{   
+                        ret = pm.getPackagesForUid(uid);
+                }
+                catch(Exception e)
+                {       Log.w(TAG, "Package Not found");
+			ret=null;                        
+                }
+                return ret;
+        }
+*/
+	//Checking if the given processName is alive
+        private boolean isAlive(String processName)
+        {
+                ActivityManager am = (ActivityManager)mContext.getSystemService(Context.ACTIVITY_SERVICE);
+                for(RunningAppProcessInfo pInfo : am.getRunningAppProcesses())
+                {
+                        if(pInfo.processName.equals(processName))
+                                return true;
+                }
+                return false;
+        }
+
+	//Check caller permissions
+	private static boolean validateCaller()
+	{
+		int pid = Binder.getCallingPid();
+		String processName="";
+		IAquiferService aquifer = IAquiferService.Stub.asInterface(ServiceManager.getService("Aquifer"));
+		try{
+			processName = aquifer.getProcessName(pid);
+		}
+		catch(Exception e)
+		{}
+		if(!processName.equals("system") && pid!=0)
+		{
+			System.out.println("AquiferService::Dropping call from "+processName);
+			return false;
+		}
+		else 
+			return true;
+	}
+
+	void printMsg(int pid)
+	{
+		System.out.println("Printing pid:"+pid);
+	}
+	
+	public void workflowJoin(String a,int b,String c,int d, String e,int f,int g, String h)
+	{}
+
+	void addActionToList(String action, ArrayList<Integer> finalPolicy)
+	{
+		finalPolicy.add(action.length());
+		for(int i=0;i<action.length();i++)
+			 finalPolicy.add((int)(action.charAt(i)));
+	}
+	String getActionFromList(ArrayList<Integer> policy)
+	{
+		Iterator<Integer> iterator = policy.iterator();
+		int length = iterator.next();
+		String action = "";
+		while(iterator.hasNext())
+		{
+			int nextASCII = iterator.next();
+			action+=(char)(nextASCII);
+		}
+		return action;
+	}
+/************************************************************************************************************/
+
+
+/**********************************************************************************************************************/
+	/*
+	 *NATIVE METHODS
+	 *
+	 */
+	//For checking AquiferPolicy in the kernel. Not important in the current implementation.
+	private static native int checkAquiferNative(int pid1, int pid2, int flow);	
+  
+	//Adds the internet flag to the task_struct of a process
+	private static native int addInetFlag(int pid, int flag);	
+	
+	//temp method to test jni
+	private native int democall(int n);
+	
+/**********************************************************************************************************************/
+	//Supporting Sub-classes
+	//The Label Class
+	private class WLabel
+	{
+		private ArrayList<Participant> ParticipantList;
+		private ArrayList<Participant> HistoryList;
+		private HashMap<String, Policy> PolicyMap;
+		//Constructor	
+		WLabel()
+		{
+			ParticipantList = new ArrayList<Participant>(); 
+			HistoryList = new ArrayList<Participant>(); 
+			PolicyMap = new HashMap<String, Policy>();
+		}
+		
+		//Getters & Setters not necessary since we can directly access
+		//members of WLabel from the FLoidService. Still, do these later.
+		
+		//Getting the Effective Policy
+		private Policy effectivePolicy()
+		{
+			Policy policy = new Policy();
+			for ( String packageName : PolicyMap.keySet())
+			{
+				policy = Policy.policyJoin(policy, PolicyMap.get(packageName));
+			}
+			return policy;
+		}
+		private void displayLabel()
+		{	//System.out.println("Policies:");
+			for ( String packageName : PolicyMap.keySet())
+                        {
+				 //System.out.println("Policy For "+packageName);
+                                 PolicyMap.get(packageName).displayPolicy();
+                        }
+		}
+	}
+  }
+
